stages:
  - validate
  - release
  - renovate_bot

include:
  - local: .gitlab-ci-asdf-versions.yml

  # This template should be included in all Infrastructure projects.
  # It includes standard checks, gitlab-scanners, validations and release processes
  # common to all projects using this template library.
  # see https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/README.md#templatesstandardyml
  - project: gitlab-com/gl-infra/common-ci-tasks
    ref: v2.42  # renovate:managed
    file: templates/standard.yml

  # Includes a base template for running kaniko easily
  # see https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/kaniko.md
  - project: gitlab-com/gl-infra/common-ci-tasks
    ref: v2.42  # renovate:managed
    file: kaniko.yml

.container_builds:
  stage: release
  parallel:
    matrix:
      - CONTAINER_DIRECTORY: jb
        CONTAINER_IMAGE_NAME: jb:v${GL_ASDF_JB_VERSION}
      - CONTAINER_DIRECTORY: go-jsonnet
        CONTAINER_IMAGE_NAME: go-jsonnet:v${GL_ASDF_GO_JSONNET_VERSION}
  variables:
    KANIKO_BUILD_FILE: ${CONTAINER_DIRECTORY}/Dockerfile
    KANIKO_EXTRA_ARGS: |
      --build-arg GL_ASDF_GO_JSONNET_VERSION
      --build-arg GL_ASDF_GOLANG_VERSION
      --build-arg GL_ASDF_JB_VERSION
  extends:
    - .kaniko_base

container_image_build:
  needs: []
  variables:
    KANIKO_DESTINATION: $CI_REGISTRY_IMAGE/test/$CONTAINER_IMAGE_NAME
  extends:
    - .container_builds
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

# Tags use the git tag, not the slug
container_image_default_branch:
  variables:
    KANIKO_DESTINATION: $CI_REGISTRY_IMAGE/$CONTAINER_IMAGE_NAME
  extends:
    - .container_builds
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
